## libfiu 0.13

=== libfiu/Makefile ===

CFLAGS += -std=c99 -pedantic -Wall -O3
ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 $(CFLAGS)

ifdef DEBUG
ALL_CFLAGS += -g
endif

ifdef PROFILE
ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
endif


# prefix for installing the binaries
PREFIX=/usr/local

# prefix for eventual location of binaries
DESTDIR=$(PREFIX)

# install utility, we assume it's GNU/BSD compatible
INSTALL=install


OBJS = fiu.o fiu-rc.o


ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
else
	NICE_CC = $(CC)
endif

LIB_VER=0.13
LIB_SO_VER=0


default: all

all: libs libfiu.pc

libfiu.pc: build-flags libfiu.pc.in
	@echo "generating libfiu.pc"
	@cat libfiu.pc.in | \
		sed 's@++DESTDIR++@$(DESTDIR)@g' | \
		sed 's@++LIB_VER++@$(LIB_VER)@g' \
		> libfiu.pc

libs: libfiu.so libfiu.a

libfiu.so: build-flags fiu.h $(OBJS)
	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC \
		-Wl,-soname,libfiu.so.$(LIB_SO_VER) \
		$(OBJS) -lpthread -o libfiu.so.$(LIB_VER)
	ln -fs libfiu.so.$(LIB_VER) libfiu.so

libfiu.a: build-flags fiu.h $(OBJS)
	$(AR) cr libfiu.a $(OBJS)


install-lib: libs libfiu.pc
	$(INSTALL) -d $(PREFIX)/lib
	$(INSTALL) -m 0755 libfiu.so.$(LIB_VER) $(PREFIX)/lib
	ln -fs libfiu.so.$(LIB_VER) $(PREFIX)/lib/libfiu.so
	ln -fs libfiu.so.$(LIB_VER) $(PREFIX)/lib/libfiu.so.$(LIB_SO_VER)
	$(INSTALL) -m 0755 libfiu.a $(PREFIX)/lib
	$(INSTALL) -d $(PREFIX)/include
	$(INSTALL) -m 0644 fiu.h $(PREFIX)/include
	$(INSTALL) -m 0644 fiu-control.h $(PREFIX)/include
	$(INSTALL) -m 0644 fiu-local.h $(PREFIX)/include
	$(INSTALL) -d $(PREFIX)/lib/pkgconfig
	$(INSTALL) -m 644 libfiu.pc $(PREFIX)/lib/pkgconfig
	@echo
	@echo "Please run ldconfig to update your library cache"
	@echo

install-man:
	$(INSTALL) -d $(PREFIX)/share/man/man3
	$(INSTALL) -m 0644 libfiu.3 $(PREFIX)/share/man/man3/

install: install-lib install-man

uninstall-lib:
	$(RM) $(PREFIX)/lib/libfiu.so
	$(RM) $(PREFIX)/lib/libfiu.so.$(LIB_VER)
	$(RM) $(PREFIX)/lib/libfiu.so.$(LIB_SO_VER)
	$(RM) $(PREFIX)/lib/libfiu.a
	$(RM) $(PREFIX)/include/fiu.h
	$(RM) $(PREFIX)/include/fiu-control.h
	$(RM) $(PREFIX)/include/fiu-local.h
	$(RM) $(PREFIX)/lib/pkgconfig/libfiu.pc

uninstall-man:
	$(RM) $(PREFIX)/share/man/man3/libfiu.3

uninstall: uninstall-lib uninstall-man


BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi

$(OBJS): build-flags

.c.o:
	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@

clean:
	rm -f libfiu.pc $(OBJS) libfiu.so libfiu.so.$(LIB_VER) libfiu.a
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags

.PHONY: default all libs \
	install-lib install-man install \
	uninstall-lib uninstall-man uninstall \
	clean \
	.force-build-flags

=== preload/posix/Makefile ===

CFLAGS += -std=c99 -Wall -O3
ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 \
		-I. -I../../libfiu/ -L../../libfiu/ $(CFLAGS)

ifdef DEBUG
ALL_CFLAGS += -g
endif

ifdef PROFILE
ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
endif

# prefix for installing the binaries
PREFIX=/usr/local

# install utility, we assume it's GNU/BSD compatible
INSTALL=install


MODS = $(wildcard modules/*.mod)
GEN_C = $(addsuffix .c,$(MODS))
GEN_OBJS = $(addsuffix .o,$(MODS))
GEN_FL = $(addsuffix .fl,$(MODS))
CUSTOM_OBJS = $(patsubst %.c,%.o,$(wildcard modules/*.custom.c))
OBJS = codegen.o $(GEN_OBJS) $(CUSTOM_OBJS)


ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
	NICE_GEN = @echo "  GEN $@"; ./generate
	Q = @
else
	NICE_CC = $(CC)
	NICE_GEN = ./generate
	Q =
endif


default: all
	
all: fiu_posix_preload.so function_list

BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi

$(GEN_OBJS): $(GEN_C)

$(OBJS): build-flags

%.mod.c: %.mod
	$(NICE_GEN) $< $@ $<.fl

.c.o:
	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@

# some platforms do not have libdl, we only use it if available
NEED_LIBDL := $(shell ld -o dlcheck.so -shared -ldl 2>/dev/null && echo -ldl; \
	rm -f dlcheck.so)

fiu_posix_preload.so: build-flags $(OBJS)
	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $(OBJS) -lfiu $(NEED_LIBDL) \
		-o fiu_posix_preload.so

# this should only be needed when building the function list and not the
# preload library
%.mod.fl: %.mod
	$(NICE_GEN) $< $<.c $@

function_list: $(GEN_FL) function_list.in
	@echo "  function_list"
	$(Q) cp function_list.in function_list
	$(Q) for i in $(GEN_FL); do cat $$i >> function_list; done

install: fiu_posix_preload.so
	$(INSTALL) -d $(PREFIX)/lib
	$(INSTALL) -m 0755 fiu_posix_preload.so $(PREFIX)/lib

uninstall:
	$(RM) $(PREFIX)/lib/fiu_posix_preload.so

clean:
	rm -f $(OBJS) $(GEN_OBJS:.o=.c) $(GEN_FL) build-flags
	rm -f function_list fiu_posix_preload.so
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out

.PHONY: default install uninstall clean .force-build-flags

=== preload/run/Makefile ===

CFLAGS += -std=c99 -Wall -O3
ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 \
		-I. -I../../libfiu/ -L../../libfiu/ $(CFLAGS)

ifdef DEBUG
ALL_CFLAGS += -g
endif

ifdef PROFILE
ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
endif

# prefix for installing the binaries
PREFIX=/usr/local

# location of preload libraries
PLIBPATH=$(PREFIX)/lib

# install utility, we assume it's GNU/BSD compatible
INSTALL=install


OBJS = run.o


ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
else
	NICE_CC = $(CC)
endif


default: all
	
all: fiu_run_preload.so fiu-run

BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi

$(OBJS): build-flags

.c.o:
	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@

# some platforms do not have libdl, we only use it if available
NEED_LIBDL := $(shell ld -o dlcheck.so -shared -ldl 2>/dev/null && echo -ldl; \
	rm -f dlcheck.so)

fiu_run_preload.so: build-flags $(OBJS)
	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $(OBJS) -lfiu $(NEED_LIBDL) \
		-o fiu_run_preload.so

fiu-run: build-flags fiu-run.in
	cat fiu-run.in | sed "s+@@PLIBPATH@@+$(PLIBPATH)+g" > fiu-run
	chmod +x fiu-run

install: fiu_run_preload.so fiu-run
	$(INSTALL) -d $(PREFIX)/lib
	$(INSTALL) -m 0755 fiu_run_preload.so $(PREFIX)/lib
	$(INSTALL) -d $(PREFIX)/bin
	$(INSTALL) -m 0755 fiu-run $(PREFIX)/bin
	$(INSTALL) -d $(PREFIX)/share/man/man1
	$(INSTALL) -m 0644 fiu-run.1 $(PREFIX)/share/man/man1/

uninstall:
	$(RM) $(PREFIX)/lib/fiu_run_preload.so
	$(RM) $(PREFIX)/bin/fiu-run
	$(RM) $(PREFIX)/share/man/man1/fiu-run.1

clean:
	rm -f $(OBJS) fiu_run_preload.so fiu-run build-flags
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out

.PHONY: default install uninstall clean .force-build-flags

=== debian/changelog ===
libfiu (0.13-3) unstable; urgency=low

  * Normalise override disparity by moving fiu-utils from "libdevel" to "devel"
  * Add patch to fix run-time abort on *BSD platforms. (Closes: #574752)

 -- Chris Lamb <lamby@debian.org>  Mon, 22 Mar 2010 07:22:19 +0000

libfiu (0.13-2) unstable; urgency=low

  * Add patch from upstream to determine location of libc.so.6 dynamically due
    to being named differently on IA64 and alpha. (Closes: #574405)
  * Bump Standards-Version to 3.8.4.

 -- Chris Lamb <lamby@debian.org>  Thu, 18 Mar 2010 10:41:03 +0000

libfiu (0.13-1) unstable; urgency=low

  * New upstream release.
  * Drop 01-add-version-to-Makefile.diff, 02-add-soname.diff, 
    03-manpage-hyphens.diff, 04-manpage-dir.diff, 05-destdir-pkgconfig.diff,
    and 06-plibpath.diff: all applied upstream.
  * Bump Standards-Version to 3.8.3.
  * Bump Build-Depends on debhelper to 7.5.0~ as override functionality used.

 -- Chris Lamb <lamby@debian.org>  Sun, 18 Oct 2009 23:25:46 +0100

libfiu (0.12-1) unstable; urgency=low

  * Initial release. (Closes: #536732)

 -- Chris Lamb <lamby@debian.org>  Sat, 25 Jul 2009 12:43:58 +0200

=== debian/control ===
Source: libfiu
Section: libs
Priority: optional
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends: debhelper (>= 7.0.50~), python-dev, python-docutils
Standards-Version: 3.8.4
Homepage: http://blitiri.com.ar/p/libfiu/
Vcs-Git: git://git.chris-lamb.co.uk/debian/pkg-libfiu.git
Vcs-Browser: http://git.chris-lamb.co.uk/?p=debian/pkg-libfiu.git

Package: libfiu0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: userspace fault injection framework
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains the libfiu shared library. To perform fault injection,
 you will require the "libfiu-dev" package.

Package: fiu-utils
Section: devel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfiu0 (= ${binary:Version})
Description: userspace fault injection framework (utilities)
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains the fiu-run, fiu-ls and fiu-ctrl utilities.

Package: libfiu-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfiu0 (= ${binary:Version})
Description: userspace fault injection framework (development libraries)
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains the development libraries and documentation in HTML and
 reStructuredText formats.

Package: python-fiu
Section: python
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, libfiu0 (= ${binary:Version})
Description: userspace fault injection framework (Python bindings)
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains Python bindings to libfiu.

=== debian/rules ===
#!/usr/bin/make -f

DOCS = $(patsubst %.rst,%.html, $(wildcard doc/*.rst))

%:
	dh $@

clean:
	rm -f doc/*.html

doc/%.html: doc/%.rst
	rst2html $< > $@
	
override_dh_auto_build: $(DOCS)
	dh_auto_build
	cd bindings/python && python setup.py build

override_dh_auto_install:
	make install PREFIX=$(CURDIR)/debian/tmp/usr DESTDIR=/usr PLIBPATH=/usr/lib/fiu
	cd bindings/python && python setup.py install --root=$(CURDIR)/debian/python-fiu --no-compile -O0 --install-layout=deb

override_dh_compress:
	dh_compress -X.rst

## libfiu 0.14

=== Makefile ===


default: all

install: all_install

uninstall: all_uninstall

all: libfiu preload utils

all_install: libfiu_install preload_install utils_install

all_uninstall: libfiu_uninstall preload_uninstall utils_uninstall


libfiu:
	$(MAKE) -C libfiu

libfiu_clean:
	$(MAKE) -C libfiu clean

libfiu_install:
	$(MAKE) -C libfiu install

libfiu_uninstall:
	$(MAKE) -C libfiu uninstall


preload: libfiu
	$(MAKE) -C preload

preload_clean:
	$(MAKE) -C preload clean

preload_install: preload
	$(MAKE) -C preload install

preload_uninstall:
	$(MAKE) -C preload uninstall


utils:
	$(MAKE) -C utils

utils_clean:
	$(MAKE) -C utils clean

utils_install: utils
	$(MAKE) -C utils install

utils_uninstall:
	$(MAKE) -C utils uninstall


bindings: python2 python3

bindings_install: python2_install python3_install

bindings_clean: python_clean

python2: libfiu
	cd bindings/python && python setup.py build

python2_install: python2
	cd bindings/python && python setup.py install

python3: libfiu
	cd bindings/python && python3 setup.py build

python3_install: python3
	cd bindings/python && python3 setup.py install

python_clean:
	cd bindings/python && rm -rf build/


clean: python_clean preload_clean libfiu_clean utils_clean


.PHONY: default all clean install all_install uninstall all_uninstall \
	libfiu libfiu_clean libfiu_install libfiu_uninstall \
	python2 python2_install python3 python3_install python_clean \
	bindings bindings_install bindings_clean \
	preload preload_clean preload_install preload_uninstall \
	utils utils_clean utils_install utils_uninstall

=== libfiu/Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 	NICE_CC = $(CC)
 endif
 
-LIB_VER=0.13
+LIB_VER=0.14
 LIB_SO_VER=0

=== preload/posix/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 CFLAGS += -std=c99 -Wall -O3
 ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 \
-		-I. -I../../libfiu/ -L../../libfiu/ $(CFLAGS)
+		-I. -I../../libfiu/ $(CFLAGS)
 
 ifdef DEBUG
 ALL_CFLAGS += -g
@@ -60,13 +60,36 @@
 .c.o:
 	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@
 
+
 # some platforms do not have libdl, we only use it if available
-NEED_LIBDL := $(shell ld -o dlcheck.so -shared -ldl 2>/dev/null && echo -ldl; \
-	rm -f dlcheck.so)
+build-needlibdl:
+	@$(LD) -ldl -o dlcheck.so 2>/dev/null \
+		&& echo -ldl > $@ || echo > $@
+	@rm -f dlcheck.so
 
-fiu_posix_preload.so: build-flags $(OBJS)
-	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $(OBJS) -lfiu $(NEED_LIBDL) \
+# libc's soname depends on the platform (most use libc.so.6, but for example
+# ia64 and alpha use libc.so.6.1), so find which one to use at build-time.
+# Please note that the argument to ldd *must* start with "./", otherwise some
+# "ldd"s won't work (for example, the one in FreeBSD 8.1).
+build-libcsoname:
+	@$(CC) -x c /dev/null -lc -shared -o build-libccheck.so
+	@ldd ./build-libccheck.so | grep libc.so | awk '{ print $$1 }' > $@
+	@rm build-libccheck.so
+	@test "`cat $@`" != "" || \
+		(echo "Error finding soname, please report"; rm $@; exit 1)
+
+build-env.h: build-env.h.in build-libcsoname
+	@echo "  GEN $@"
+	$(Q) sed "s+@@LIBC_SONAME@@+`cat build-libcsoname`+g" build-env.h.in \
+		> build-env.h
+
+
+fiu_posix_preload.so: build-flags build-env.h build-needlibdl $(OBJS)
+	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $(OBJS) \
+		-L../../libfiu/ \
+		-lfiu `cat build-needlibdl` \
 		-o fiu_posix_preload.so
+
 
 # this should only be needed when building the function list and not the
 # preload library
@@ -86,7 +109,8 @@
 	$(RM) $(PREFIX)/lib/fiu_posix_preload.so
 
 clean:
-	rm -f $(OBJS) $(GEN_OBJS:.o=.c) $(GEN_FL) build-flags
+	rm -f $(OBJS) $(GEN_OBJS:.o=.c) $(GEN_FL)
+	rm -f build-flags build-env.h build-libcsoname build-needlibdl
 	rm -f function_list fiu_posix_preload.so
 	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out

=== debian/changelog ===
libfiu (0.14-2) unstable; urgency=low

  * Add missing Build-Depends on python-support. (Closes: #642450)

 -- Chris Lamb <lamby@debian.org>  Wed, 16 Nov 2011 17:38:10 +0000

libfiu (0.14-1) unstable; urgency=low

  * New upstream release.
    - Drop "01_libc6_location.diff"; applied upstream.
    - Drop "02_mode_t_freebsd.diff"; applied upstream.
  * Update Vcs-{Git,Browser}.
  * Bump Standards-Version to 3.9.1.
  * Bump Standards-Version to 3.9.2.

 -- Chris Lamb <lamby@debian.org>  Fri, 15 Jul 2011 16:19:14 +0100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: libs
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), python-dev, python-docutils
-Standards-Version: 3.8.4
+Build-Depends: debhelper (>= 7.0.50~), python-dev, python-docutils, python-support
+Standards-Version: 3.9.2
 Homepage: http://blitiri.com.ar/p/libfiu/
-Vcs-Git: git://git.chris-lamb.co.uk/debian/pkg-libfiu.git
-Vcs-Browser: http://git.chris-lamb.co.uk/?p=debian/pkg-libfiu.git
+Vcs-Git: git://github.com/lamby/pkg-libfiu.git
+Vcs-Browser: https://github.com/lamby/pkg-libfiu
 
 Package: libfiu0
 Architecture: any

## libfiu 0.90

=== Makefile ===
--- 
+++ 
@@ -51,6 +51,8 @@
 utils_uninstall:
 	$(MAKE) -C utils uninstall
 
+test: libfiu bindings
+	$(MAKE) -C tests
 
 bindings: python2 python3
 
@@ -82,6 +84,7 @@
 	python2 python2_install python3 python3_install python_clean \
 	bindings bindings_install bindings_clean \
 	preload preload_clean preload_install preload_uninstall \
-	utils utils_clean utils_install utils_uninstall
+	utils utils_clean utils_install utils_uninstall \
+	test

=== libfiu/Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 INSTALL=install
 
 
-OBJS = fiu.o fiu-rc.o
+OBJS = fiu.o fiu-rc.o backtrace.o
 
 
 ifneq ($(V), 1)
@@ -30,8 +30,19 @@
 	NICE_CC = $(CC)
 endif
 
-LIB_VER=0.14
+LIB_VER=0.90
 LIB_SO_VER=0
+
+
+# We attempt to detect if we have the extensions we use in backtrace.c by just
+# attempting to compile it normally, and fall back to the dummy version if
+# that fails. Not very sophisticated but should be safe.
+USE_DUMMY_BACKTRACE := $(shell $(CC) -c backtrace.c -o /dev/null 2>/dev/null || \
+	echo -DDUMMY_BACKTRACE)
+ifndef USE_DUMMY_BACKTRACE
+# The real backtrace needs linking against libdl.
+USE_LIBDL = -ldl
+endif
 
 
 default: all
@@ -50,8 +61,9 @@
 libfiu.so: build-flags fiu.h $(OBJS)
 	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC \
 		-Wl,-soname,libfiu.so.$(LIB_SO_VER) \
-		$(OBJS) -lpthread -o libfiu.so.$(LIB_VER)
+		$(OBJS) -lpthread $(USE_LIBDL) -o libfiu.so.$(LIB_VER)
 	ln -fs libfiu.so.$(LIB_VER) libfiu.so
+	ln -fs libfiu.so.$(LIB_VER) libfiu.so.$(LIB_SO_VER)
 
 libfiu.a: build-flags fiu.h $(OBJS)
 	$(AR) cr libfiu.a $(OBJS)
@@ -104,19 +116,29 @@
 		echo "$(BF)" > build-flags; \
 	fi
 
+
 $(OBJS): build-flags
 
 .c.o:
 	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@
 
+backtrace.o: ALL_CFLAGS += $(USE_DUMMY_BACKTRACE)
+
+
+doxygen:
+	        $(MAKE) LIB_VER=$(LIB_VER) -C doxygen
+
+
 clean:
-	rm -f libfiu.pc $(OBJS) libfiu.so libfiu.so.$(LIB_VER) libfiu.a
+	rm -f libfiu.pc $(OBJS)
+	rm -f libfiu.so libfiu.so.$(LIB_VER) libfiu.so.$(LIB_SO_VER) libfiu.a
 	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags
+	$(MAKE) -C doxygen $@
 
 .PHONY: default all libs \
 	install-lib install-man install \
 	uninstall-lib uninstall-man uninstall \
-	clean \
+	doxygen clean \
 	.force-build-flags

=== tests/Makefile ===

CFLAGS += -std=c99 -pedantic -Wall -rdynamic
ALL_CFLAGS = -I../libfiu/ -L../libfiu/ \
	-D_XOPEN_SOURCE=600 -D_GNU_SOURCE -fPIC -DFIU_ENABLE=1 $(CFLAGS)

ifdef DEBUG
ALL_CFLAGS += -g
endif

ifdef PROFILE
ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
endif

ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
	NICE_RUN = @echo "  RUN $<"; LD_LIBRARY_PATH=../libfiu/
	NICE_PY_RUN = @echo "  PY  $<"; \
		      LD_LIBRARY_PATH=../libfiu/ \
		      PYTHONPATH=../bindings/python/
else
	NICE_CC = $(CC)
	NICE_RUN = LD_LIBRARY_PATH=../libfiu/
	NICE_PY_RUN = LD_LIBRARY_PATH=../libfiu/ \
		      PYTHONPATH=../bindings/python/
endif

default: tests

all: tests

tests: c-tests py-tests

#
# C tests
#

C_SRCS := $(wildcard test-*.c)
C_OBJS := $(patsubst %.c,%.o,$(C_SRCS))
C_BINS := $(patsubst %.c,%,$(C_SRCS))

c-tests: $(patsubst %.c,c-run-%,$(C_SRCS))

test-%: test-%.o build-flags
	$(NICE_CC) $(ALL_CFLAGS) $< -lfiu -o $@

c-run-%: %
	$(NICE_RUN) ./$<


BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi

.c.o:
	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@


#
# Python tests
#

PY_TESTS := $(wildcard test-*.py)

py-tests: $(patsubst %.py,py-run-%,$(PY_TESTS))

py-run-%: %.py
	$(NICE_PY_RUN) python ./$<


clean:
	# Normally, $C_OBJS and $C_BINS are removed by make after building,
	# since here they're considered "intermediate files"; however we
	# also remove them when cleaning just in case.
	rm -f $(C_OBJS) $(C_BINS)
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags

FORCE:

.PHONY: default all clean \
	tests c-tests py-tests \
	.force-build-flags

=== debian/changelog ===
libfiu (0.90-3) unstable; urgency=low

  * Make passing the testsuite optional; upstream does not 100% rely on it yet
    on all architectures.

 -- Chris Lamb <lamby@debian.org>  Wed, 11 Apr 2012 11:19:27 +0100

libfiu (0.90-2) unstable; urgency=low

  * Apply patch from upstream to attempt to fix broken builds.
    <http://blitiri.com.ar/git/?p=libfiu;a=commit;h=005a56fbcb5ab8045f9d51676c521b335f058552>

 -- Chris Lamb <lamby@debian.org>  Fri, 06 Apr 2012 19:03:08 +0100

libfiu (0.90-1) unstable; urgency=low

  * New upstream release.
  * Add python3-dev to Build-Depends.
  * Add patch from upstream to fix Python tests.
    <http://blitiri.com.ar/git/?p=libfiu;a=commit;h=83fb1e675de26ad5409e554e2947e53c8f1b10c0>
  * Update symbols.

 -- Chris Lamb <lamby@debian.org>  Thu, 05 Apr 2012 09:26:02 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libs
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), python-dev, python-docutils, python-support
+Build-Depends: debhelper (>= 7.0.50~), python-dev, python-docutils, python-support, python3-dev
 Standards-Version: 3.9.2
 Homepage: http://blitiri.com.ar/p/libfiu/
 Vcs-Git: git://github.com/lamby/pkg-libfiu.git

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,9 @@
 
 doc/%.html: doc/%.rst
 	rst2html $< > $@
+
+override_dh_auto_test: 
+	dh_auto_test || true
 	
 override_dh_auto_build: $(DOCS)
 	dh_auto_build

## libfiu 0.91

=== libfiu/Makefile ===
--- 
+++ 
@@ -30,15 +30,15 @@
 	NICE_CC = $(CC)
 endif
 
-LIB_VER=0.90
+LIB_VER=0.91
 LIB_SO_VER=0
 
 
 # We attempt to detect if we have the extensions we use in backtrace.c by just
 # attempting to compile it normally, and fall back to the dummy version if
 # that fails. Not very sophisticated but should be safe.
-USE_DUMMY_BACKTRACE := $(shell $(CC) -c backtrace.c -o /dev/null 2>/dev/null || \
-	echo -DDUMMY_BACKTRACE)
+USE_DUMMY_BACKTRACE := $(shell $(CC) $(ALL_CFLAGS) -c backtrace.c \
+	-o /dev/null 2>/dev/null || echo -DDUMMY_BACKTRACE)
 ifndef USE_DUMMY_BACKTRACE
 # The real backtrace needs linking against libdl.
 USE_LIBDL = -ldl

=== tests/Makefile ===
--- 
+++ 
@@ -14,21 +14,18 @@
 ifneq ($(V), 1)
 	NICE_CC = @echo "  CC  $@"; $(CC)
 	NICE_RUN = @echo "  RUN $<"; LD_LIBRARY_PATH=../libfiu/
-	NICE_PY_RUN = @echo "  PY  $<"; \
-		      LD_LIBRARY_PATH=../libfiu/ \
-		      PYTHONPATH=../bindings/python/
+	NICE_PY = @echo "  PY  $<"; ./wrap-python 2
 else
 	NICE_CC = $(CC)
 	NICE_RUN = LD_LIBRARY_PATH=../libfiu/
-	NICE_PY_RUN = LD_LIBRARY_PATH=../libfiu/ \
-		      PYTHONPATH=../bindings/python/
+	NICE_PY = ./wrap-python 2
 endif
 
 default: tests
 
 all: tests
 
-tests: c-tests py-tests
+tests: c-tests py-tests gen-tests
 
 #
 # C tests
@@ -69,15 +66,27 @@
 py-tests: $(patsubst %.py,py-run-%,$(PY_TESTS))
 
 py-run-%: %.py
-	$(NICE_PY_RUN) python ./$<
+	$(NICE_PY) ./$<
+
+#
+# Generated tests
+#
+
+gen-tests:
+	$(MAKE) -C generated
 
 
+#
+# Cleanup
+#
+
+# Normally, $C_OBJS and $C_BINS are removed by make after building,
+# since here they're considered "intermediate files"; however we
+# also remove them when cleaning just in case.
 clean:
-	# Normally, $C_OBJS and $C_BINS are removed by make after building,
-	# since here they're considered "intermediate files"; however we
-	# also remove them when cleaning just in case.
 	rm -f $(C_OBJS) $(C_BINS)
 	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags
+	$(MAKE) -C generated clean
 
 FORCE:

=== debian/changelog ===
libfiu (0.91-2) unstable; urgency=low

  * Require the testsuite to pass at request of upstream - was optional since
    0.90-3.
  * Add/fix support for python3:
    - Add python3-fiu binary to debian/control
    - Adjust debian/rules to build for all versions
    - Change python/python3 build deps to python{3}-all-dev to support build
      for all versions
    Thanks to Scott Kitterman <debian@kitterman.com>.
  * Move to dh_python2. Thanks to Scott Kitterman <debian@kitterman.com>.

 -- Chris Lamb <lamby@debian.org>  Thu, 23 May 2013 00:49:47 +0100

libfiu (0.91-1) unstable; urgency=low

  * New upstream release.
  * Update symbols.
  * Drop 01_wrap_python_for_tests.diff - applied upstream.
  * Drop 02_include_stdlib.diff - applied upstream.

 -- Chris Lamb <lamby@debian.org>  Thu, 06 Sep 2012 02:29:33 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libs
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), python-dev, python-docutils, python-support, python3-dev
+Build-Depends: debhelper (>= 7.0.50~), python-all-dev, python-docutils, python3-all-dev
 Standards-Version: 3.9.2
 Homepage: http://blitiri.com.ar/p/libfiu/
 Vcs-Git: git://github.com/lamby/pkg-libfiu.git
@@ -52,3 +52,14 @@
  enable/disable the failure of those points (the "control API").
  .
  This package contains Python bindings to libfiu.
+
+Package: python3-fiu
+Section: python
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, libfiu0 (= ${binary:Version})
+Description: userspace fault injection framework (Python 3 bindings)
+ libfiu is a C library for fault injection. It provides functions to mark
+ "points of failure" inside your code (the "core API"), and functions to
+ enable/disable the failure of those points (the "control API").
+ .
+ This package contains Python 3 bindings to libfiu.

## libfiu 0.92

=== Makefile ===
--- 
+++ 
@@ -51,8 +51,15 @@
 utils_uninstall:
 	$(MAKE) -C utils uninstall
 
-test: libfiu bindings
+
+tests: test
+
+test: libfiu bindings preload
 	$(MAKE) -C tests
+
+test_clean:
+	$(MAKE) -C tests clean
+
 
 bindings: python2 python3
 
@@ -76,7 +83,7 @@
 	cd bindings/python && rm -rf build/
 
 
-clean: python_clean preload_clean libfiu_clean utils_clean
+clean: python_clean preload_clean libfiu_clean utils_clean test_clean
 
 
 .PHONY: default all clean install all_install uninstall all_uninstall \
@@ -85,6 +92,6 @@
 	bindings bindings_install bindings_clean \
 	preload preload_clean preload_install preload_uninstall \
 	utils utils_clean utils_install utils_uninstall \
-	test
+	test tests test_clean

=== libfiu/Makefile ===
--- 
+++ 
@@ -1,13 +1,18 @@
 
-CFLAGS += -std=c99 -pedantic -Wall -O3
+CFLAGS += -std=c99 -pedantic -Wall
 ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 $(CFLAGS)
 
+# Optimization CFLAGS, only used when doing a non-debug build.
+OPT_CFLAGS = -O3
+
 ifdef DEBUG
-ALL_CFLAGS += -g
-endif
-
-ifdef PROFILE
-ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
+    ALL_CFLAGS += -g
+else
+   ifdef PROFILE
+        ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
+   else
+       ALL_CFLAGS += $(OPT_CFLAGS)
+   endif
 endif
 
 
@@ -21,7 +26,7 @@
 INSTALL=install
 
 
-OBJS = fiu.o fiu-rc.o backtrace.o
+OBJS = fiu.o fiu-rc.o backtrace.o wtable.o hash.o
 
 
 ifneq ($(V), 1)
@@ -30,7 +35,7 @@
 	NICE_CC = $(CC)
 endif
 
-LIB_VER=0.91
+LIB_VER=0.92
 LIB_SO_VER=0

=== tests/Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 c-tests: $(patsubst %.c,c-run-%,$(C_SRCS))
 
 test-%: test-%.o build-flags
-	$(NICE_CC) $(ALL_CFLAGS) $< -lfiu -o $@
+	$(NICE_CC) $(ALL_CFLAGS) $< -lfiu -lpthread -o $@
 
 c-run-%: %
 	$(NICE_RUN) ./$<

=== preload/posix/Makefile ===
--- 
+++ 
@@ -60,6 +60,10 @@
 .c.o:
 	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@
 
+# We define _GNU_SOURCE to get RTLD_NEXT if available; on non-GNU
+# platforms it should be harmless.
+codegen.o: codegen.c
+	$(NICE_CC) $(ALL_CFLAGS) -D_GNU_SOURCE -c $< -o $@
 
 # some platforms do not have libdl, we only use it if available
 build-needlibdl:

=== preload/run/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 CFLAGS += -std=c99 -Wall -O3
 ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 \
-		-I. -I../../libfiu/ -L../../libfiu/ $(CFLAGS)
+		-I. -I../../libfiu/ $(CFLAGS)
 
 ifdef DEBUG
 ALL_CFLAGS += -g
@@ -49,13 +49,20 @@
 .c.o:
 	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@
 
+
 # some platforms do not have libdl, we only use it if available
-NEED_LIBDL := $(shell ld -o dlcheck.so -shared -ldl 2>/dev/null && echo -ldl; \
-	rm -f dlcheck.so)
+build-needlibdl:
+	@$(LD) -ldl -o dlcheck.so 2>/dev/null \
+		&& echo -ldl > $@ || echo > $@
+	@rm -f dlcheck.so
 
-fiu_run_preload.so: build-flags $(OBJS)
-	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $(OBJS) -lfiu $(NEED_LIBDL) \
+
+fiu_run_preload.so: build-flags build-needlibdl $(OBJS)
+	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $(OBJS) \
+		-L../../libfiu/ \
+		-lfiu `cat build-needlibdl` \
 		-o fiu_run_preload.so
+
 
 fiu-run: build-flags fiu-run.in
 	cat fiu-run.in | sed "s+@@PLIBPATH@@+$(PLIBPATH)+g" > fiu-run

=== tests/generated/Makefile ===

CFLAGS += -std=c99 -pedantic -Wall -rdynamic
ALL_CFLAGS = -I../../libfiu/ -L../../libfiu/ \
	-D_XOPEN_SOURCE=600 -D_GNU_SOURCE -fPIC -DFIU_ENABLE=1 $(CFLAGS)

ifdef DEBUG
ALL_CFLAGS += -g
endif

ifdef PROFILE
ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
endif

ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
	NICE_RUN = @echo "  RUN $<"; \
		   LD_LIBRARY_PATH=../../libfiu/ \
		   LD_PRELOAD="../../preload/run/fiu_run_preload.so \
		   	../../preload/posix/fiu_posix_preload.so"
	NICE_GEN = @echo "  GEN $@"; ./generate-test
else
	NICE_CC = $(CC)
	NICE_RUN = LD_LIBRARY_PATH=../../libfiu/ \
		   LD_PRELOAD="../../preload/run/fiu_run_preload.so \
		   	../../preload/posix/fiu_posix_preload.so"
	NICE_GEN = ./generate-test
endif

default: tests

all: tests


CONF := $(wildcard tests/*.conf)
GEN_BIN := $(patsubst %.conf,%.bin,$(CONF))

tests: $(patsubst %,%-run,$(GEN_BIN))

%-run: %
	$(NICE_RUN) ./$<

# .bin from .c
%.bin: %.c build-flags
	$(NICE_CC) $(ALL_CFLAGS) $< -lfiu -o $@

# .c from .conf
%.c: %.conf generate-test
	$(NICE_GEN) -c $< -o $@

# Useful for manually generating the C-files, that otherwise get deleted as
# intermediates.
c-files: $(patsubst %.conf,%.c,$(CONF))


BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi


#
# Cleanup
#

clean:
	rm -f $(GEN_BIN) $(patsubst %.bin,%.c,$(GEN_BIN))
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags

FORCE:

.PHONY: default all clean \
	tests c-tests py-tests \
	.force-build-flags

=== debian/changelog ===
libfiu (0.92-1build2) trusty; urgency=medium

  * No change rebuild to drop python3.3 compiled extension.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 31 Mar 2014 23:53:40 +0100

libfiu (0.92-1build1) trusty; urgency=medium

  * Rebuild for python3.4 as a supported python version.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 04 Jan 2014 18:31:16 +0000

libfiu (0.92-1) unstable; urgency=low

  * New upstream release.
  * Add "this work is to be considered Public Domain" to debian/copyright.
    Thanks to Ansgar Burchardt.
  * Bump Standards-Version to 3.9.4.
  * Update debian/symbols.

 -- Chris Lamb <lamby@debian.org>  Wed, 30 Oct 2013 11:20:24 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: libfiu
 Section: libs
 Priority: optional
-Maintainer: Chris Lamb <lamby@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), python-all-dev, python-docutils, python3-all-dev
-Standards-Version: 3.9.2
+Standards-Version: 3.9.4
 Homepage: http://blitiri.com.ar/p/libfiu/
 Vcs-Git: git://github.com/lamby/pkg-libfiu.git
 Vcs-Browser: https://github.com/lamby/pkg-libfiu

=== debian/rules ===
#!/usr/bin/make -f

DOCS = $(patsubst %.rst,%.html, $(wildcard doc/*.rst))
buildvers := $(shell pyversions -sv)
build3vers := $(shell py3versions -sv)

%:
	dh $@ --with python3,python2

clean:
	rm -f doc/*.html

doc/%.html: doc/%.rst
	rst2html $< > $@

override_dh_auto_build: $(DOCS)
	dh_auto_build
	cd bindings/python \
	set -e && for i in $(buildvers); do \
	  python$$i ./setup.py build; \
	done
	cd bindings/python \
	set -e && for i in $(build3vers); do \
	  python$$i ./setup.py build; \
	done

override_dh_auto_install:
	make install PREFIX=$(CURDIR)/debian/tmp/usr DESTDIR=/usr PLIBPATH=/usr/lib/fiu
	cd bindings/python \
	set -e && for i in $(buildvers); do \
	  python$$i ./setup.py install --root=$(CURDIR)/debian/python-fiu --no-compile -O0 --install-layout=deb; \
	done
	cd bindings/python \
	set -e && for i in $(build3vers); do \
	  python$$i ./setup.py install --root=$(CURDIR)/debian/python3-fiu --no-compile -O0 --install-layout=deb; \
	done

override_dh_compress:
	dh_compress -X.rst

## libfiu 0.93

=== libfiu/Makefile ===
--- 
+++ 
@@ -15,6 +15,9 @@
    endif
 endif
 
+ifdef TRACE
+    ALL_CFLAGS += -DFIU_TRACE=1
+endif
 
 # prefix for installing the binaries
 PREFIX=/usr/local
@@ -35,7 +38,7 @@
 	NICE_CC = $(CC)
 endif
 
-LIB_VER=0.92
+LIB_VER=0.93
 LIB_SO_VER=0
 
 
@@ -43,7 +46,7 @@
 # attempting to compile it normally, and fall back to the dummy version if
 # that fails. Not very sophisticated but should be safe.
 USE_DUMMY_BACKTRACE := $(shell $(CC) $(ALL_CFLAGS) -c backtrace.c \
-	-o /dev/null 2>/dev/null || echo -DDUMMY_BACKTRACE)
+	-o backtrace-check.o || echo -DDUMMY_BACKTRACE)
 ifndef USE_DUMMY_BACKTRACE
 # The real backtrace needs linking against libdl.
 USE_LIBDL = -ldl
@@ -135,7 +138,7 @@
 
 
 clean:
-	rm -f libfiu.pc $(OBJS)
+	rm -f libfiu.pc $(OBJS) backtrace-check.o
 	rm -f libfiu.so libfiu.so.$(LIB_VER) libfiu.so.$(LIB_SO_VER) libfiu.a
 	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags
 	$(MAKE) -C doxygen $@

=== tests/Makefile ===
--- 
+++ 
@@ -15,17 +15,33 @@
 	NICE_CC = @echo "  CC  $@"; $(CC)
 	NICE_RUN = @echo "  RUN $<"; LD_LIBRARY_PATH=../libfiu/
 	NICE_PY = @echo "  PY  $<"; ./wrap-python 2
+	NICE_LN = @echo "  LN $@"; ln -f
 else
 	NICE_CC = $(CC)
 	NICE_RUN = LD_LIBRARY_PATH=../libfiu/
 	NICE_PY = ./wrap-python 2
+	NICE_LN = ln -f
 endif
 
 default: tests
 
 all: tests
 
-tests: c-tests py-tests gen-tests
+tests: c-tests py-tests gen-tests utils-tests
+
+
+# Link the libraries to a single place, some of the tests need this.
+libs:
+	mkdir -p libs/
+
+libs/fiu_posix_preload.so: ../preload/posix/fiu_posix_preload.so libs
+	$(NICE_LN) $< libs/
+
+libs/fiu_run_preload.so: ../preload/run/fiu_run_preload.so libs
+	$(NICE_LN) $< libs/
+
+lnlibs: libs/fiu_posix_preload.so libs/fiu_run_preload.so
+
 
 #
 # C tests
@@ -65,16 +81,19 @@
 
 py-tests: $(patsubst %.py,py-run-%,$(PY_TESTS))
 
-py-run-%: %.py
+py-run-%: %.py lnlibs
 	$(NICE_PY) ./$<
 
+
 #
-# Generated tests
+# Sub-directory tests
 #
 
 gen-tests:
 	$(MAKE) -C generated
 
+utils-tests:
+	$(MAKE) -C utils
 
 #
 # Cleanup
@@ -85,13 +104,14 @@
 # also remove them when cleaning just in case.
 clean:
 	rm -f $(C_OBJS) $(C_BINS)
+	rm -rf libs/
 	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags
 	$(MAKE) -C generated clean
 
 FORCE:
 
 .PHONY: default all clean \
-	tests c-tests py-tests \
+	tests c-tests py-tests gen-tests utils-tests \
 	.force-build-flags

=== preload/posix/Makefile ===
--- 
+++ 
@@ -1,7 +1,8 @@
 
 CFLAGS += -std=c99 -Wall -O3
 ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 \
-		-I. -I../../libfiu/ $(CFLAGS)
+		-D_LARGEFILE64_SOURCE=1 -I. -I../../libfiu/ \
+		$(CFLAGS)
 
 ifdef DEBUG
 ALL_CFLAGS += -g
@@ -10,6 +11,11 @@
 ifdef PROFILE
 ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
 endif
+
+ifdef POSIX_TRACE
+    ALL_CFLAGS += -DFIU_POSIX_TRACE=1
+endif
+
 
 # prefix for installing the binaries
 PREFIX=/usr/local
@@ -52,7 +58,7 @@
 
 $(GEN_OBJS): $(GEN_C)
 
-$(OBJS): build-flags
+$(OBJS): build-flags codegen.h
 
 %.mod.c: %.mod
 	$(NICE_GEN) $< $@ $<.fl
@@ -62,7 +68,7 @@
 
 # We define _GNU_SOURCE to get RTLD_NEXT if available; on non-GNU
 # platforms it should be harmless.
-codegen.o: codegen.c
+codegen.o: codegen.c build-flags
 	$(NICE_CC) $(ALL_CFLAGS) -D_GNU_SOURCE -c $< -o $@
 
 # some platforms do not have libdl, we only use it if available
@@ -117,6 +123,8 @@
 	rm -f build-flags build-env.h build-libcsoname build-needlibdl
 	rm -f function_list fiu_posix_preload.so
 	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out
+	rm -f modules/*.bb modules/*.bbg modules/*.da
+	rm -f modules/*.gcov modules/*.gcda modules/*.gcno modules/gmon.out
 
 .PHONY: default install uninstall clean .force-build-flags

=== debian/changelog ===
libfiu (0.93-2) unstable; urgency=low

  * Add patch from upstream to fix FTBFS on i386.

 -- Chris Lamb <lamby@debian.org>  Wed, 30 Jul 2014 10:44:42 +0100

libfiu (0.93-1) unstable; urgency=medium

  * New upstream release.
  * Strip Debian revision from symbols.

 -- Chris Lamb <lamby@debian.org>  Tue, 29 Jul 2014 07:43:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: libfiu
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Chris Lamb <lamby@debian.org>
+Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), python-all-dev, python-docutils, python3-all-dev
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://blitiri.com.ar/p/libfiu/
 Vcs-Git: git://github.com/lamby/pkg-libfiu.git
 Vcs-Browser: https://github.com/lamby/pkg-libfiu

## libfiu 0.94

=== libfiu/Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 	NICE_CC = $(CC)
 endif
 
-LIB_VER=0.93
+LIB_VER=0.94
 LIB_SO_VER=0
 
 
@@ -66,9 +66,10 @@
 
 libs: libfiu.so libfiu.a
 
-libfiu.so: build-flags fiu.h $(OBJS)
+libfiu.so: build-flags symbols.map fiu.h $(OBJS)
 	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC \
 		-Wl,-soname,libfiu.so.$(LIB_SO_VER) \
+		-Wl,--version-script=symbols.map \
 		$(OBJS) -lpthread $(USE_LIBDL) -o libfiu.so.$(LIB_VER)
 	ln -fs libfiu.so.$(LIB_VER) libfiu.so
 	ln -fs libfiu.so.$(LIB_VER) libfiu.so.$(LIB_SO_VER)

=== tests/Makefile ===
--- 
+++ 
@@ -27,7 +27,7 @@
 
 all: tests
 
-tests: c-tests py-tests gen-tests utils-tests
+tests: c-tests py-tests gen-tests utils-tests collisions-tests
 
 
 # Link the libraries to a single place, some of the tests need this.
@@ -81,9 +81,11 @@
 
 py-tests: $(patsubst %.py,py-run-%,$(PY_TESTS))
 
-py-run-%: %.py lnlibs
+py-run-%: %.py lnlibs small-cat
 	$(NICE_PY) ./$<
 
+small-cat: small-cat.c
+	$(NICE_CC) $(ALL_CFLAGS) $< -o $@
 
 #
 # Sub-directory tests
@@ -95,6 +97,9 @@
 utils-tests:
 	$(MAKE) -C utils
 
+collisions-tests:
+	$(MAKE) -C collisions
+
 #
 # Cleanup
 #
@@ -104,7 +109,7 @@
 # also remove them when cleaning just in case.
 clean:
 	rm -f $(C_OBJS) $(C_BINS)
-	rm -rf libs/
+	rm -rf libs/ small-cat
 	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags
 	$(MAKE) -C generated clean

=== preload/posix/Makefile ===
--- 
+++ 
@@ -68,7 +68,7 @@
 
 # We define _GNU_SOURCE to get RTLD_NEXT if available; on non-GNU
 # platforms it should be harmless.
-codegen.o: codegen.c build-flags
+codegen.o: codegen.c build-flags build-env.h
 	$(NICE_CC) $(ALL_CFLAGS) -D_GNU_SOURCE -c $< -o $@
 
 # some platforms do not have libdl, we only use it if available

=== tests/collisions/Makefile ===

CFLAGS += -std=c99 -pedantic -Wall -rdynamic
ALL_CFLAGS = -I../../libfiu/ -L../../libfiu/ -L./ \
	-D_XOPEN_SOURCE=600 -D_GNU_SOURCE -fPIC -DFIU_ENABLE=1 $(CFLAGS)

ifdef DEBUG
ALL_CFLAGS += -g
endif

ifdef PROFILE
ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
endif

ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
	NICE_RUN = @echo "  RUN $<"; \
		   LD_LIBRARY_PATH="./:../../libfiu/"
	NICE_LN = @echo "  LN $@"; ln -f
else
	NICE_CC = $(CC)
	NICE_RUN = LD_LIBRARY_PATH="./:../../libfiu/"
	NICE_LN = ln -f
endif

default: tests

all: tests


BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi

#
# Test library and binaries.
#

libcoltest.so: libcoltest.c libcoltest.h
	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $< -o $@

binary: binary.c libcoltest.so
	$(NICE_CC) $(ALL_CFLAGS) -L. $< -lfiu -lcoltest -o $@


tests: binary
	$(NICE_RUN) ./binary

#
# Cleanup
#

clean:
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags
	rm -f libcoltest.so binary

FORCE:

.PHONY: default all clean \
	tests c-tests py-tests \
	.force-build-flags

=== debian/changelog ===
libfiu (0.94-4) unstable; urgency=medium

  * wrap-and-sort -sa.
  * Add debian/patches/0002-ld-as-needed.patch from Logan Rosen
    <logan@ubuntu.com>: Move libraries after files that
    need them to fix FTBFS with ld --as-needed. (Closes: #819373)
  * Move to HTTPS URI for Vcs-Git.

 -- Chris Lamb <lamby@debian.org>  Mon, 28 Mar 2016 23:48:24 +0400

libfiu (0.94-3) unstable; urgency=medium

  * Pass LC_ALL=C when running dh_auto_test to avoid FTBFS under exotic locales
    (eg. fr_CH.UTF-8).

 -- Chris Lamb <lamby@debian.org>  Tue, 22 Sep 2015 15:54:19 +0100

libfiu (0.94-2) unstable; urgency=medium

  * Don't hide compiler warnings by passing V=1 to upstream Makefiles.
  * Rename buildvers -> PYTHON2_VERSIONS, etc.
  * Apply upstream patch to fix FTBFS in tests on amd64.

 -- Chris Lamb <lamby@debian.org>  Sun, 16 Aug 2015 13:42:18 +0200

libfiu (0.94-1) unstable; urgency=medium

  * New upstream version.
  * Bump Standards-Version to 3.9.6.
  * Bump Debhelper compatibility level to 9.
  * wrap-and-sort.
  * Drop 01-fix-ftbfs-on-i386.diff - applied upstream.
  * Add dh-python to Build-Depends.
  * Update debian/symbols.

 -- Chris Lamb <lamby@debian.org>  Sat, 15 Aug 2015 10:57:19 +0200

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,22 @@
 Section: libs
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), python-all-dev, python-docutils, python3-all-dev
-Standards-Version: 3.9.5
+Build-Depends:
+ debhelper (>= 9),
+ dh-python,
+ python-all-dev,
+ python-docutils,
+ python3-all-dev
+Standards-Version: 3.9.6
 Homepage: http://blitiri.com.ar/p/libfiu/
-Vcs-Git: git://github.com/lamby/pkg-libfiu.git
+Vcs-Git: https://github.com/lamby/pkg-libfiu
 Vcs-Browser: https://github.com/lamby/pkg-libfiu
 
 Package: libfiu0
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends}
 Description: userspace fault injection framework
  libfiu is a C library for fault injection. It provides functions to mark
  "points of failure" inside your code (the "core API"), and functions to
@@ -22,7 +29,10 @@
 Package: fiu-utils
 Section: devel
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libfiu0 (= ${binary:Version})
+Depends:
+ libfiu0 (= ${binary:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends}
 Description: userspace fault injection framework (utilities)
  libfiu is a C library for fault injection. It provides functions to mark
  "points of failure" inside your code (the "core API"), and functions to
@@ -33,7 +43,10 @@
 Package: libfiu-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libfiu0 (= ${binary:Version})
+Depends:
+ libfiu0 (= ${binary:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends}
 Description: userspace fault injection framework (development libraries)
  libfiu is a C library for fault injection. It provides functions to mark
  "points of failure" inside your code (the "core API"), and functions to
@@ -45,7 +58,11 @@
 Package: python-fiu
 Section: python
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, libfiu0 (= ${binary:Version})
+Depends:
+ libfiu0 (= ${binary:Version}),
+ ${misc:Depends},
+ ${python:Depends},
+ ${shlibs:Depends}
 Description: userspace fault injection framework (Python bindings)
  libfiu is a C library for fault injection. It provides functions to mark
  "points of failure" inside your code (the "core API"), and functions to
@@ -56,7 +73,11 @@
 Package: python3-fiu
 Section: python
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, libfiu0 (= ${binary:Version})
+Depends:
+ libfiu0 (= ${binary:Version}),
+ ${misc:Depends},
+ ${python3:Depends},
+ ${shlibs:Depends}
 Description: userspace fault injection framework (Python 3 bindings)
  libfiu is a C library for fault injection. It provides functions to mark
  "points of failure" inside your code (the "core API"), and functions to

=== debian/rules ===
#!/usr/bin/make -f

DOCS = $(patsubst %.rst,%.html, $(wildcard doc/*.rst))
PYTHON2_VERSIONS := $(shell pyversions -sv)
PYTHON3_VERSIONS := $(shell py3versions -sv)

%:
	dh $@ --with python3,python2

clean:
	rm -f doc/*.html

doc/%.html: doc/%.rst
	rst2html $< > $@

override_dh_auto_build: $(DOCS)
	dh_auto_build -- V=1
	cd bindings/python \
	set -e && for i in $(PYTHON2_VERSIONS); do \
	  python$$i ./setup.py build; \
	done
	cd bindings/python \
	set -e && for i in $(PYTHON3_VERSIONS); do \
	  python$$i ./setup.py build; \
	done

override_dh_auto_test:
	dh_auto_test -- V=1 LC_ALL=C

override_dh_auto_install:
	make install PREFIX=$(CURDIR)/debian/tmp/usr DESTDIR=/usr PLIBPATH=/usr/lib/fiu
	cd bindings/python \
	set -e && for i in $(PYTHON2_VERSIONS); do \
	  python$$i ./setup.py install --root=$(CURDIR)/debian/python-fiu --no-compile -O0 --install-layout=deb; \
	done
	cd bindings/python \
	set -e && for i in $(PYTHON3_VERSIONS); do \
	  python$$i ./setup.py install --root=$(CURDIR)/debian/python3-fiu --no-compile -O0 --install-layout=deb; \
	done

override_dh_compress:
	dh_compress -X.rst
